apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ jitsi_name }}
  name: {{ jitsi_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ jitsi_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ jitsi_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ jitsi_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ jitsi_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ jitsi_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ jitsi_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DISABLE_HTTPS
          value: "1"
        - name: ENABLE_AUTH
          value: "{{ 1 if (do_ldap) else 0 }}"
        - name: ENABLE_GUESTS
          value: "{{ 1 if (jitsi_enable_guests) else 0 }}"
        - name: ENABLE_HTTP_REDIRECT
          value: "0"
        - name: JICOFO_AUTH_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ jicofo_name }}
        - name: JICOFO_AUTH_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ jicofo_name }}
        - name: PUBLIC_URL
          value: "https://{{ jitsi_fqdn }}"
        - name: TZ
          value: {{ timezone }}
        - name: XMPP_AUTH_DOMAIN
          value: auth.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_BOSH_URL_BASE
          value: http://{{ prosody_name }}.{{ namespace }}.svc.{{ cluster_domain }}:5280
        - name: XMPP_DOMAIN
          value: meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_GUEST_DOMAIN
          value: guest.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_INTERNAL_MUC_DOMAIN
          value: internal-muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_MUC_DOMAIN
          value: muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_RECORDER_DOMAIN
          value: recorder.meet.{{ namespace }}.svc.{{ cluster_domain }}
{% if do_triggers == False or (opsimages | json_query("[?name=='jitsi'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='jitsi'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          httpGet:
            path: /
            port: 80
        name: web
        ports:
        - containerPort: 80
          name: http
        - containerPort: 443
          name: https
        resources:
          limits:
            cpu: "{{ jitsi_web_cpu_limit }}"
            memory: "{{ jitsi_web_memory_limit }}"
          requests:
            cpu: "{{ jitsi_web_cpu_request }}"
            memory: "{{ jitsi_web_memory_request }}"
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /config
          name: data
          subPath: config
        - mountPath: /usr/share/jitsi-meet/transcripts
          name: data
          subPath: transcripts
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      serviceAccountName: {{ jitsi_name }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ jitsi_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ jitsi_name }}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='jitsi'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - jitsi
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='jitsi'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
